;File: 				Basic_Sample1.bb
;Author: 			Silver_Knee
;Description: 		Demonstriert die einfachste Anwendung der BlitzEvents.
;Original Uploaded: www.BlitzForum.de

Include "BlitzEvent_Basic.bb"

Graphics 800,600,32,2
SetBuffer BackBuffer()

Local x,y
Global KEY_DOWN,END_PROGRAM

KEY_DOWN=AddBlitzEventKind()
END_PROGRAM=AddBlitzEventKind()


Repeat
	;Eingabe
	If KeyDown(200) Or KeyDown(17);hoch
		FireBlitzEvent(KEY_DOWN,200)
	EndIf
	
	If KeyDown(203) Or KeyDown(30);links
		FireBlitzEvent(KEY_DOWN,203)
	EndIf
	
	If KeyDown(205) Or KeyDown(32);rechts
		FireBlitzEvent(KEY_DOWN,205)
	EndIf
	
	If KeyDown(208) Or KeyDown(31);runter
		FireBlitzEvent(KEY_DOWN,208)
	EndIf
	
	If KeyDown(1)
		FireBlitzEvent(END_PROGRAM,0)
	EndIf
	
	;Verarbeitung
	While NextBlitzEvent()
		Select BlitzEventKind
			Case KEY_DOWN
				Select BlitzEventInfo
					Case 200:y=y-1
					Case 203:x=x-1
					Case 205:x=x+1
					Case 208:y=y+1
				End Select
			Case END_PROGRAM
				End
			Case BLITZEVENT_ERROR
				Delete Object.BlitzEventError(BlitzEventInfo);ein Error verfllt.
		End Select
	Wend;Vor diesem Wend mssen alle Objekte, die als Handle in einer BlitzEventInfo liegen, gelscht werden.
	
	;Ausgabe
	Rect x,y,10,10
	Flip
	Cls
Forever
;~IDEal Editor Parameters:
;~C#Blitz3D