;File: 				Basic_Sample1.bb
;Author: 			Silver_Knee
;Description: 		Demonstriert die BlitzEvents beim Zusammenfhren verschiedener Auslder,
;					die das gleiche Ereignis nach sich ziehen.
;Original Uploaded: www.BlitzForum.de

Include "BlitzEvent_Basic.bb"

Graphics 800,600,32,2
SetBuffer BackBuffer()

Local x,y,mo.Movement_Type
Global Movement,END_PROGRAM

Movement=AddBlitzEventKind()
END_PROGRAM=AddBlitzEventKind()

Type Movement_Type
	Field x,y
End Type

Repeat
	;Eingabe
	If KeyDown(200) Or KeyDown(17);hoch
		mo=New Movement_Type
		mo\x=0
		mo\y=-2
		FireBlitzEvent(Movement,Handle(mo))	;Dadurch, dass der Handle des Types bergeben wird,
											;ist er spter wieder reproduzierbar.
	EndIf
	
	If KeyDown(203) Or KeyDown(30);links
		mo=New Movement_Type
		mo\x=-2
		mo\y=0
		FireBlitzEvent(Movement,Handle(mo))	;Dadurch, dass der Handle des Types bergeben wird,
											;ist er spter wieder reproduzierbar.
	EndIf
	
	If KeyDown(205) Or KeyDown(32);rechts
		mo=New Movement_Type
		mo\x=+2
		mo\y=0
		FireBlitzEvent(Movement,Handle(mo))	;Dadurch, dass der Handle des Types bergeben wird,
											;ist er spter wieder reproduzierbar.
	EndIf
	
	If KeyDown(208) Or KeyDown(31);runter
		mo=New Movement_Type
		mo\x=0
		mo\y=+2
		FireBlitzEvent(Movement,Handle(mo))	;Dadurch, dass der Handle des Types bergeben wird,
											;ist er spter wieder reproduzierbar.
	EndIf
	
	If RectsOverlap(x,y,10,10,100,100,200,50)
		mo=New Movement_Type
		mo\x=4
		mo\y=0
		FireBlitzEvent(Movement,Handle(mo))	;Dadurch, dass der Handle des Types bergeben wird,
											;ist er spter wieder reproduzierbar.
	EndIf
	
	If KeyDown(1)
		FireBlitzEvent(END_PROGRAM,0)
	EndIf
	
	;Verarbeitung
	While NextBlitzEvent()
		Select BlitzEventKind
			Case Movement
				mo=Object.Movement_Type(BlitzEventInfo)
				x=x+mo\x
				y=y+mo\y
			Case BLITZEVENT_ERROR
				Delete Object.BlitzEventError(BlitzEventInfo);Errors verfallen
			Case END_PROGRAM
				End		
		End Select
	Wend;Vor diesem Wend mssen alle Objekte, die als Handle in einer BlitzEventInfo liegen, gelscht werden.
	
	;Ausgabe
	
	;>Power-Feld-Effekt
	Rect 100,100,200,50,0
	Viewport 100,100,200,50
	Line ((MilliSecs()/10-50) Mod 200),150,((MilliSecs()/10-50) Mod 200)+50,125
	Line ((MilliSecs()/10-50) Mod 200),100,((MilliSecs()/10-50) Mod 200)+50,125
	
	Line ((MilliSecs()/10) Mod 200)+50,150,((MilliSecs()/10) Mod 200)+100,125
	Line ((MilliSecs()/10) Mod 200)+50,100,((MilliSecs()/10) Mod 200)+100,125
	
	Line ((MilliSecs()/10+50) Mod 200)+100,150,((MilliSecs()/10+50) Mod 200)+150,125
	Line ((MilliSecs()/10+50) Mod 200)+100,100,((MilliSecs()/10+50) Mod 200)+150,125
	
	Line ((MilliSecs()/10+100) Mod 200)+150,150,((MilliSecs()/10+100) Mod 200)+200,125
	Line ((MilliSecs()/10+100) Mod 200)+150,100,((MilliSecs()/10+100) Mod 200)+200,125
	
	Line ((MilliSecs()/10+150) Mod 200)+200,150,((MilliSecs()/10+150) Mod 200)+250,125
	Line ((MilliSecs()/10+150) Mod 200)+200,100,((MilliSecs()/10+150) Mod 200)+250,125
	Viewport 0,0,800,600
	;<Power-Feld-Effekt
	
	Rect x,y,10,10
	Flip 
	Cls
Forever
;~IDEal Editor Parameters:
;~C#Blitz3D